#include <cppunit/plugin/DynamicLibraryManagerException.h>

#include <atlbase.h>
#include <atlconv.h>

#if !defined(CPPUNIT_NO_TESTPLUGIN)

CPPUNIT_NS_BEGIN


DynamicLibraryManagerException::DynamicLibraryManagerException( 
                                         const M_STD_STRING &libraryName,
                                         const M_STD_STRING &errorDetail,
                                         Cause cause )
    : m_cause( cause )
    , std::runtime_error( "" )
{
  try {
    if ( cause == loadingFailed )
      m_message = "Failed to load dynamic library: " + std::string(M2A(libraryName.c_str())) + "\n" + 
                  std::string(M2A(errorDetail.c_str()));
    else
      m_message = "Symbol [" + std::string(M2A(errorDetail.c_str())) + "] not found in dynamic libary:" + 
                  std::string(M2A(libraryName.c_str()));
  }
  catch(...) {
    
  }
}


DynamicLibraryManagerException::Cause 
DynamicLibraryManagerException::getCause() const
{
  return m_cause;
}


const char *
DynamicLibraryManagerException::what() const throw()
{
  return m_message.c_str();
}

CPPUNIT_NS_END


#endif // !defined(CPPUNIT_NO_TESTPLUGIN)
