#include <cppunit/tools/StringTools.h>
#include <algorithm>


CPPUNIT_NS_BEGIN


M_STD_STRING 
StringTools::toString( int value )
{
  OStringStream stream;
  stream << value;
  return stream.str();
}


M_STD_STRING 
StringTools::toString( double value )
{
  OStringStream stream;
  stream << value;
  return stream.str();
}


StringTools::Strings
StringTools::split( const M_STD_STRING &text, 
                    TCHAR separator )
{
  Strings splittedText;

  M_STD_STRING::const_iterator itStart = text.begin();
  while ( !text.empty() )
  {
    M_STD_STRING::const_iterator itSeparator = std::find( itStart, 
                                                         text.end(), 
                                                         separator );
    splittedText.push_back( text.substr( itStart - text.begin(),
                                         itSeparator - itStart ) );
    if ( itSeparator == text.end() )
      break;
    itStart = itSeparator +1;
  }

  return splittedText;
}


M_STD_STRING 
StringTools::wrap( const M_STD_STRING &text,
                   int wrapColumn )
{
  const TCHAR lineBreak = _T('\n');
  Strings lines = split( text, lineBreak );

  M_STD_STRING wrapped;
  for ( Strings::const_iterator it = lines.begin(); it != lines.end(); ++it )
  {
    if ( it != lines.begin() )
      wrapped += lineBreak;

    const M_STD_STRING &line = *it;
    unsigned int index =0;
    while ( index < line.length() )
    {
      M_STD_STRING lineSlice( line.substr( index, wrapColumn ) );
      wrapped += lineSlice;
      index += wrapColumn;
      if ( index < line.length() )
        wrapped += lineBreak;
    }
  }

  return wrapped;
}


CPPUNIT_NS_END

