#include <cppunit/extensions/TestNamer.h>
#include <cppunit/extensions/TypeInfoHelper.h>
#include <string>


CPPUNIT_NS_BEGIN


#if CPPUNIT_HAVE_RTTI
TestNamer::TestNamer( const std::type_info &typeInfo )
{
  m_fixtureName = TypeInfoHelper::getClassName( typeInfo );
}
#endif


TestNamer::TestNamer( const M_STD_STRING &fixtureName )
  : m_fixtureName( fixtureName )
{
}


TestNamer::~TestNamer()
{
}


M_STD_STRING 
TestNamer::getFixtureName() const
{
  return m_fixtureName;
}


M_STD_STRING 
TestNamer::getTestNameFor( const M_STD_STRING &testMethodName ) const
{
  return getFixtureName() + _T("::") + testMethodName;
}




CPPUNIT_NS_END
