#include <cppunit/Exception.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TextTestResult.h>
#include <cppunit/TextOutputter.h>
#include <iostream>


CPPUNIT_NS_BEGIN


TextTestResult::TextTestResult()
{
  addListener( this );
}


void 
TextTestResult::addFailure( const TestFailure &failure )
{
  TestResultCollector::addFailure( failure );
  M_STD_CERR << ( failure.isError() ? _T("E") : _T("F") );
}


void 
TextTestResult::startTest( Test *test )
{
  TestResultCollector::startTest (test);
  M_STD_CERR << _T(".");
}


void 
TextTestResult::print( M_STD_OSTREAM& stream ) 
{
  TextOutputter outputter( this, stream );
  outputter.write();
}


M_STD_OSTREAM &
operator <<( M_STD_OSTREAM &stream, 
             TextTestResult &result )
{ 
  result.print (stream); return stream; 
}


CPPUNIT_NS_END
