#include <cppunit/Portability.h>

#if defined(CPPUNIT_HAVE_UNIX_DLL_LOADER)
#include <cppunit/plugin/DynamicLibraryManager.h>

#include <dlfcn.h>
#include <unistd.h>


CPPUNIT_NS_BEGIN


DynamicLibraryManager::LibraryHandle 
DynamicLibraryManager::doLoadLibrary( const M_STD_STRING &libraryName )
{
  return ::dlopen( CT2A(libraryName.c_str()), RTLD_NOW | RTLD_GLOBAL );
}


void 
DynamicLibraryManager::doReleaseLibrary()
{
  ::dlclose( m_libraryHandle);
}


DynamicLibraryManager::Symbol 
DynamicLibraryManager::doFindSymbol( const M_STD_STRING &symbol )
{
  return ::dlsym ( m_libraryHandle, CT2A( symbol.c_str() ) );
}


M_STD_STRING 
DynamicLibraryManager::getLastErrorDetail() const
{
  return _T("");
}


CPPUNIT_NS_END


#endif // defined(CPPUNIT_HAVE_UNIX_DLL_LOADER)
