#pragma once

#include <cppunit/Portability.h>

#if !defined(CPPUNIT_NO_TESTPLUGIN)

#include <cppunit/portability/CppUnitDeque.h>
#include <string>

CPPUNIT_NS_BEGIN

/*! \brief Test plug-ins parameters.
 */
class CPPUNIT_API PlugInParameters
{
public:
  /// Constructs plug-in parameters from the specified command-line.
  PlugInParameters( const M_STD_STRING &commandLine = _T("") );

  virtual ~PlugInParameters();

  /// Returns the command line that was passed on construction.
  M_STD_STRING getCommandLine() const;

private:
  M_STD_STRING m_commandLine;
};


CPPUNIT_NS_END

#endif // !defined(CPPUNIT_NO_TESTPLUGIN)


